/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package servicos;

import java.awt.Color;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.UIManager;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author Ricardo.Alves
 */
public class tela extends javax.swing.JFrame {

    /**
     * Creates new form tela
     */
    public tela() {
        initComponents();
        tab.setDefaultRenderer(Object.class, new PINTAR_TABELA());
                tab.setSelectionBackground(Color.WHITE);
                tab.setSelectionForeground(Color.PINK);
           }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        painel = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tab = new javax.swing.JTable();
        parar = new javax.swing.JButton();
        iniciar = new javax.swing.JButton();
        pararTudo = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        logger = new javax.swing.JTextArea();
        jLabel1 = new javax.swing.JLabel();
        TrocarRPO = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        config = new javax.swing.JLabel();
        ExcConfig = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Administrador de serviços");
        setResizable(false);
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                formComponentShown(evt);
            }
        });

        painel.setBackground(new java.awt.Color(0, 0, 0));
        painel.setLayout(null);

        tab.setBackground(new java.awt.Color(51, 51, 51));
        tab.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        tab.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Serviço", "Status"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tab.setGridColor(new java.awt.Color(255, 255, 255));
        tab.setSelectionBackground(new java.awt.Color(255, 255, 255));
        tab.setSelectionForeground(new java.awt.Color(51, 255, 255));
        tab.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                tabComponentShown(evt);
            }
        });
        jScrollPane1.setViewportView(tab);
        if (tab.getColumnModel().getColumnCount() > 0) {
            tab.getColumnModel().getColumn(0).setResizable(false);
            tab.getColumnModel().getColumn(1).setResizable(false);
            tab.getColumnModel().getColumn(1).setPreferredWidth(10);
        }

        painel.add(jScrollPane1);
        jScrollPane1.setBounds(10, 11, 350, 500);

        parar.setBackground(new java.awt.Color(51, 51, 51));
        parar.setFont(new java.awt.Font("Yu Gothic UI", 1, 14)); // NOI18N
        parar.setForeground(new java.awt.Color(255, 255, 255));
        parar.setText("Parar");
        parar.setBorder(null);
        parar.setContentAreaFilled(false);
        parar.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        parar.setOpaque(true);
        parar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pararActionPerformed(evt);
            }
        });
        painel.add(parar);
        parar.setBounds(450, 60, 140, 50);

        iniciar.setBackground(new java.awt.Color(51, 51, 51));
        iniciar.setFont(new java.awt.Font("Yu Gothic UI", 1, 14)); // NOI18N
        iniciar.setForeground(new java.awt.Color(255, 255, 255));
        iniciar.setText("Iniciar");
        iniciar.setBorder(null);
        iniciar.setContentAreaFilled(false);
        iniciar.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        iniciar.setOpaque(true);
        iniciar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                iniciarActionPerformed(evt);
            }
        });
        painel.add(iniciar);
        iniciar.setBounds(660, 60, 140, 50);

        pararTudo.setBackground(new java.awt.Color(51, 51, 51));
        pararTudo.setFont(new java.awt.Font("Yu Gothic UI", 1, 14)); // NOI18N
        pararTudo.setForeground(new java.awt.Color(255, 255, 255));
        pararTudo.setText("Parar tudo");
        pararTudo.setBorder(null);
        pararTudo.setContentAreaFilled(false);
        pararTudo.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        pararTudo.setOpaque(true);
        pararTudo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pararTudoActionPerformed(evt);
            }
        });
        painel.add(pararTudo);
        pararTudo.setBounds(660, 130, 140, 50);

        jScrollPane2.setBackground(new java.awt.Color(0, 0, 0));

        logger.setEditable(false);
        logger.setBackground(new java.awt.Color(0, 0, 0));
        logger.setColumns(20);
        logger.setForeground(new java.awt.Color(0, 255, 0));
        logger.setRows(5);
        jScrollPane2.setViewportView(logger);

        painel.add(jScrollPane2);
        jScrollPane2.setBounds(360, 260, 460, 250);

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel1.setForeground(new java.awt.Color(255, 255, 255));
        jLabel1.setText("Logger:");
        painel.add(jLabel1);
        jLabel1.setBounds(370, 240, 70, 17);

        TrocarRPO.setBackground(new java.awt.Color(51, 51, 51));
        TrocarRPO.setFont(new java.awt.Font("Yu Gothic UI", 1, 14)); // NOI18N
        TrocarRPO.setForeground(new java.awt.Color(255, 255, 255));
        TrocarRPO.setText("Trocar RPO");
        TrocarRPO.setBorder(null);
        TrocarRPO.setContentAreaFilled(false);
        TrocarRPO.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        TrocarRPO.setOpaque(true);
        TrocarRPO.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                TrocarRPOActionPerformed(evt);
            }
        });
        painel.add(TrocarRPO);
        TrocarRPO.setBounds(450, 130, 140, 50);

        config.setBackground(new java.awt.Color(255, 255, 255));
        config.setIcon(new javax.swing.ImageIcon("C:\\Users\\Ricardo.ALves\\Documents\\Servicos\\Icon\\config.png")); // NOI18N
        config.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        config.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                configMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 50, Short.MAX_VALUE)
            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addComponent(config, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 50, Short.MAX_VALUE)
            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addComponent(config, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        painel.add(jPanel1);
        jPanel1.setBounds(770, 0, 50, 50);

        ExcConfig.setBackground(new java.awt.Color(51, 51, 51));
        ExcConfig.setFont(new java.awt.Font("Yu Gothic UI", 1, 14)); // NOI18N
        ExcConfig.setForeground(new java.awt.Color(255, 255, 255));
        ExcConfig.setText("Executar configs");
        ExcConfig.setBorder(null);
        ExcConfig.setContentAreaFilled(false);
        ExcConfig.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        ExcConfig.setOpaque(true);
        ExcConfig.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExcConfigActionPerformed(evt);
            }
        });
        painel.add(ExcConfig);
        ExcConfig.setBounds(660, 200, 140, 50);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(painel, javax.swing.GroupLayout.DEFAULT_SIZE, 824, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(painel, javax.swing.GroupLayout.DEFAULT_SIZE, 514, Short.MAX_VALUE)
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void tabComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_tabComponentShown

    }//GEN-LAST:event_tabComponentShown

    private void pararActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pararActionPerformed
              stopServ();
              addrow(tab, painel);
    }//GEN-LAST:event_pararActionPerformed

    private void formComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentShown
                            
        addrow(tab,painel);

    }//GEN-LAST:event_formComponentShown

    private void iniciarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_iniciarActionPerformed
        startServ();
        addrow(tab, painel);
    }//GEN-LAST:event_iniciarActionPerformed

    private void pararTudoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pararTudoActionPerformed
    Object[] options = { "Confirmar", "Cancelar" };
    int result = JOptionPane.showOptionDialog(null, "Este comando irá parar tudo(Dbacess,app's,license server e TSS)\n"
            + "Obs: O processo exibição do log após o comando é lento e demorado, recomendado usar o batch\n caso queira acompanhar em tempo real o log.", "Atenção!", JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE, null, options, options[0]);
     
    if(result==0){
         TelaLog log = new TelaLog();
         Functions func = new Functions();
         log.setVisible(true);
         func.pararTudo(log.logger);
     }
     else{System.out.println("Não");}
        
    }//GEN-LAST:event_pararTudoActionPerformed

    private void TrocarRPOActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_TrocarRPOActionPerformed
        Functions func = new Functions();
        func.TrocarRPO(logger);
    }//GEN-LAST:event_TrocarRPOActionPerformed

    private void configMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_configMouseClicked
   /*     ReadConfig read= new ReadConfig();
        try {
            read.ReadConfig(".\\src\\config\\config.txt");
        } catch (FileNotFoundException ex) {
            Logger.getLogger(tela.class.getName()).log(Level.SEVERE, null, ex);
        }*/
   
   configs conf = new configs();
   conf.setVisible(true);
 
    }//GEN-LAST:event_configMouseClicked

    private void ExcConfigActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExcConfigActionPerformed
             Functions read= new Functions();
        try {
            read.execConf("C:\\config.conf", logger);
            addrow(tab, painel);
        } catch (IOException ex) {
            Logger.getLogger(tela.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_ExcConfigActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(tela.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(tela.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(tela.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(tela.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new tela().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton ExcConfig;
    private javax.swing.JButton TrocarRPO;
    private javax.swing.JLabel config;
    private javax.swing.JButton iniciar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextArea logger;
    private javax.swing.JPanel painel;
    private javax.swing.JButton parar;
    private javax.swing.JButton pararTudo;
    private javax.swing.JTable tab;
    // End of variables declaration//GEN-END:variables
public void addrow(JTable tabela,JPanel tela){
       String[] dado;
       JLabel[] label;
        try {
            	Runtime runtime = Runtime.getRuntime();

	String cmds[] = {"cmd", "/c", "wmic /node:CARSRAP service get name,state"};

	Process proc = runtime.exec(cmds);

	InputStream inputstream = proc.getInputStream();

	InputStreamReader inputstreamreader = new InputStreamReader(inputstream);
       LineNumberReader lineCounter = new LineNumberReader(inputstreamreader);

	BufferedReader bufferedreader = new BufferedReader(inputstreamreader);

	String line;
         DefaultTableModel model = (DefaultTableModel) tabela.getModel();
          model.setNumRows(0);
          model.setColumnCount(2);
	while ((line = bufferedreader.readLine()) != null) {
            if(line.isEmpty() 
                    || line.contains("=") 
                    || line.contains("Name")){}
            else{
               dado = line.split(" ");
                if (line.contains("Running")) {

                     model.addRow(new String[]{dado[0],"Running"});
                    
                }
                if(line.contains("Stopped")){     
                     model.addRow(new String[]{dado[0],"Stopped"});

                }
                
                
             //  model.addRow(new String[]{dado[0],});
                //System.out.println(line);
            
            }
	}
        
        } catch (IOException ex) {
            Logger.getLogger(tela.class.getName()).log(Level.SEVERE, null, ex);
        } 
}
public void stopServ(){
 int[] rowSelecionadas ;
       String texto ="";
       String ErroLog ="";
       String comandosExec ="";
       rowSelecionadas = tab.getSelectedRows();
         Runtime runtime = Runtime.getRuntime();
          String comand;
        String cmds2[] = {"cmd ", "/c", "sc \\\\192.168.0.10 stop "};
          for (int i = 0; i < rowSelecionadas.length; i++) {
            
           texto = (tab.getValueAt(rowSelecionadas[i], 0).toString());
          if (rowSelecionadas.length==1) {
                comandosExec += cmds2[2]+" "+texto;              
            }
         else{
          comandosExec += cmds2[2]+" "+texto+" & ";
          }
        }
           try {
               cmds2[2]=comandosExec;
               Process proc2 = runtime.exec(cmds2);
               
               	InputStream inputstream = proc2.getInputStream();

                InputStreamReader inputstreamreader = new InputStreamReader(inputstream,"cp850");
                LineNumberReader lineCounter = new LineNumberReader(inputstreamreader);

                   BufferedReader bufferedreader = new BufferedReader(inputstreamreader);

	         String line;
               while ((line = bufferedreader.readLine()) != null) {
              
                  ErroLog += line+"\n";
                  logger.setText("");
                  logger.setText(ErroLog);
                  logger.update(logger.getGraphics());

               }
               if (ErroLog.contains("FALHA")) {
                   
               }
               else{
                   if (tab.getSelectedRowCount()==0) {
                  logger.setText(logger.getText()+"===========Selecione um serviço!=========\n");}
                   else{
                 logger.setText(logger.getText()+"\n=======Serviço(s) parado.==========");
                   }}
               
              
           } catch (IOException ex) {
               Logger.getLogger(tela.class.getName()).log(Level.SEVERE, null, ex);
           }
        
}
public void startServ(){
 int[] rowSelecionadas ;
       String texto ="";
       String ErroLog ="";
       String comandosExec ="";
       rowSelecionadas = tab.getSelectedRows();
         Runtime runtime = Runtime.getRuntime();
          String comand;
        String cmds2[] = {"cmd ", "/c", "sc \\\\192.168.0.10 start "};
        for (int i = 0; i < rowSelecionadas.length; i++) {
            
           texto = (tab.getValueAt(rowSelecionadas[i], 0).toString());
          if (rowSelecionadas.length==1) {
                comandosExec += cmds2[2]+""+texto;              
            }
         else{
          comandosExec += cmds2[2]+" "+texto+" & ";
          }
        }
           try {
               cmds2[2]=comandosExec;
               Process proc2 = runtime.exec(cmds2);
               
               	InputStream inputstream = proc2.getInputStream();

                InputStreamReader inputstreamreader = new InputStreamReader(inputstream,"cp850");
                LineNumberReader lineCounter = new LineNumberReader(inputstreamreader);

                   BufferedReader bufferedreader = new BufferedReader(inputstreamreader);

	         String line;
               while ((line = bufferedreader.readLine()) != null) {
               
                 ErroLog += line+"\n";
                  logger.setText("");
                  logger.setText(ErroLog);
                  logger.update(logger.getGraphics());

               }
               if (ErroLog.contains("FALHA")) {
                   
               }
               else{
                   if (tab.getSelectedRowCount()==0) {
                  logger.setText(logger.getText()+"===========Selecione um serviço!=========\n");}
                   else{
                 logger.setText(logger.getText()+"\n=======Serviço(s) parado.==========");
                   }}

           } catch (IOException ex) {
               Logger.getLogger(tela.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println(ex);
               System.out.println(texto);
           }
        
}
}
